/* Copyright (c) 2003 - Charles Schmidt <cschmidt2@emich.edu> */

#ifndef __SAL_CONTENT_HANDLER_H__
#define __SAL_CONTENT_HANDLER_H__

#include <nsIHelperAppLauncherDialog.h>
#include <nsIExternalHelperAppService.h>
#include <nsCExternalHandlerService.h>
#include <nsIWebProgressListener.h>
#include <nsString.h>
#include <nsIURI.h>
#include <nsILocalFile.h>
#include <nsCOMPtr.h>
#include <nsISupports.h>
#include <nsIMIMEInfo.h>

typedef enum {
	DOWNLOAD_ACTION_NONE,
	DOWNLOAD_ACTION_SAVEFORHELPER,
	DOWNLOAD_ACTION_OBJECT_NOTIFY
} DownloadAction;

#define S_CONTENT_HANDLER_CID \
 {0xf20033f7, 0x487a, 0x40e1, {0xa8, 0x4c, 0xf9, 0x95, 0x3a, 0x2e, 0xa3, 0x60}}
#define S_CONTENT_HANDLER_CLASSNAME "Sal HelperAppLauncher/Content Handler"


class SalamanderContentHandler : public nsIHelperAppLauncherDialog
{
	public:

		SalamanderContentHandler();
		virtual ~SalamanderContentHandler();

		NS_DECL_ISUPPORTS
		NS_DECL_NSIHELPERAPPLAUNCHERDIALOG
/*
	NS_METHOD FindHelperApp (void);
	NS_METHOD LaunchHelperApp (void);
	NS_METHOD ShowHelperProgressDialog (void);

	NS_METHOD GetLauncher (nsIHelperAppLauncher * *_retval);
	NS_METHOD GetContext (nsISupports * *_retval);
	NS_METHOD SetHelperApp(GnomeVFSMimeApplication *mHelperApp,
			       PRBool alwaysUse);
	NS_METHOD SynchroniseMIMEInfo (void);
*/
  private:
	nsCOMPtr<nsISupports> my_context;
	nsCOMPtr<nsIHelperAppLauncher> my_launcher;

	char *my_mime_type;

	nsCOMPtr<nsIURI> my_uri;
	PRInt64 my_time_download_started;
	nsCOMPtr<nsIFile> my_temp_file;

	nsCString my_url;
	nsCString my_scheme;

/*	NS_METHOD Init (void);
	NS_METHOD ProcessMimeInfo (void);
	NS_METHOD MIMEAskAction (void);
*/
/*	
	nsCOMPtr<nsIHelperAppLauncher> mLauncher;
	nsCOMPtr<nsISupports> mContext;

	nsCOMPtr<nsIURI> mUri;
	PRInt64 mTimeDownloadStarted;
	nsCOMPtr<nsIFile> mTempFile;

	char *mMimeType;	
	PRBool mUrlHelper;
	GnomeVFSMimeApplication *mHelperApp;
	
	nsCString mUrl;
	nsCString mScheme;

	PRBool mDownloadCanceled;
	PRBool mHelperProgress;
	
	nsCOMPtr<nsIWebProgressListener> mListener;
*/
};

#endif
