
/*menu.c
 *
 */

#include"main.h"


GdkColor mozmenu3 = { 0, 0x9999, 0x9696, 0xCBCB };
GdkColor mozmenu2 = { 0, 0x0001, 0xC8C8, 0xCBCB };
GdkColor mozmenu = { 0, 0xFFFE, 0xFFFE, 0xEEEE };
GdkColor mozmenu4 = { 0, 0x0001, 0x9797, 0x9898 };
GdkColor mozmenu5 = { 0, 0x0202, 0x9595, 0xC9C9 };
GdkColor mozmenu9 = { 0, 0xF202, 0x9000, 0x0909 };
extern GList *bookmarks;
extern GSList *window_count;
gchar *filename = NULL;
static void save_url(GtkWidget * widget, geckobrowser * mozzie);

void menu_open_new_tab(GtkMenuItem * menuitem, geckobrowser * mozzie)
{
    create_container(mozzie);
}


void about()
{
GdkPixbuf *pix;
char *file;

file="/usr/share/salamander/gfx/salamander.png";
pix =  gdk_pixbuf_new_from_file (file, NULL);
  const gchar *authors[] = {
    "Oskar Kossuth","okossuth@yahoo.com",
    NULL
  };
GtkWidget *about;
about=gnome_about_new("Salamander","0.5","Copyright (c) 2003","Software Made in Peru",authors,NULL,NULL,pix);
gtk_widget_show(about);
}

void menu_vzoomin(GtkMenuItem * menuitem, geckobrowser * mozzie)
{
    float zoom;
    gembed *hydra;

    g_print("hydra");
    hydra = get_current_browser_from_notebook(mozzie);

    if (hydra)
	mozzie->gd = hydra;
    g_print("Activado!");
    mozilla_get_zoom(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed), &zoom); 
    zoom = zoom * 100 + 10;
    /* sanity check */
    if (zoom == 0) {
	g_warning("ignoring request to set zoom to 0");
	return;
    }
    mozilla_set_zoom(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed),
		     (float) zoom / 100.0);
    mozzie->zoom = zoom;

}

void menu_vzoom100(GtkMenuItem * menuitem, geckobrowser * mozzie)
{
    float zoom;
    gembed *hydra;

    g_print("hydra");
    hydra = get_current_browser_from_notebook(mozzie);

    if (hydra)
	mozzie->gd = hydra;
    g_print("Activado!");
    mozilla_get_zoom(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed), &zoom);
    zoom = 100;
  
    if (zoom == 0) {
	g_warning("ignoring request to set zoom to 0");
	return;
    }
    mozilla_set_zoom(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed),
		     (float) zoom / 100.0);
    mozzie->zoom = zoom;

}

void menu_vzoomout(GtkMenuItem * menuitem, geckobrowser * mozzie)
{
    float zoom;
    gembed *hydra;

    g_print("hydra");
    hydra = get_current_browser_from_notebook(mozzie);

    if (hydra)
	mozzie->gd = hydra;
    g_print("Activado!");
    mozilla_get_zoom(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed), &zoom);
    zoom = zoom * 100 - 10;
    
    if (zoom == 0) {
	g_warning("ignoring request to set zoom to 0");
	return;
    }
    mozilla_set_zoom(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed),
		     (float) zoom / 100.0);
    mozzie->zoom = zoom; 
}

void menu_vsource(GtkMenuItem * menuitem, geckobrowser * mozzie)
{
    gchar *url;
    gchar *prot_url = NULL;
    geckobrowser *vsource;
    gembed *hydra;
    
    g_print("hydra");
	hydra = get_current_browser_from_notebook(mozzie);
	
    if (hydra)
	{
	 mozzie->gd = hydra;
	 g_print("Activado!");
	}
	if(loadentry > loadembed)
     url = mozzie->gd->geckourl;
	if(loadentry < loadembed)
	 url = g_strdup(gtk_entry_get_text(GTK_ENTRY(mozzie->urlEntry)));
	g_print("%s",mozzie->gd->geckourl);
    if (url == NULL || !strcmp(url, ""))
	return;


    prot_url = g_strconcat("view-source:", url, NULL);

    vsourcef=1;
    vsource = create_mozilla(GTK_MOZ_EMBED_FLAG_DEFAULTCHROME);
    gtk_widget_set_usize(vsource->gd->geckoEmbed, 500, 500);

 
    gtk_widget_show(vsource->gd->geckoEmbed);
	gtk_widget_show(vsource->notebook);
    gtk_widget_show(vsource->vbox);
    gtk_widget_show(vsource->window);
    gtk_widget_hide(vsource->menubar);
    gtk_widget_hide(vsource->hbox);
	gtk_widget_hide(vsource->toolbar);
    gtk_moz_embed_load_url(GTK_MOZ_EMBED(vsource->gd->geckoEmbed),
			   prot_url);
    g_free(prot_url);
	g_free(url);
	vsourcef=0;
    return;
}

void openfile(GtkWidget * widget, geckobrowser * mozzie)
{
    gchar *tmpfile;
    gchar *tmp = NULL;
    gembed *hydra;

    g_print("hydra");
    hydra = get_current_browser_from_notebook(mozzie);

    if (hydra)
	mozzie->gd = hydra;
    g_print("Activado!");
    /* --- Which file? --- */
    tmpfile =
	gtk_file_selection_get_filename(GTK_FILE_SELECTION
					(mozzie->fileopendialog));

    /* --- Free old memory --- */
    if (filename)
	g_free(filename);

    /* --- Duplicate the string --- */
    tmp = g_strdup(tmpfile);
    filename = g_strdup(tmp);
    filename = g_strdup_printf("file:%s", filename);
    g_print("%s \n", filename);

    /* --- Close the dialog --- */
    gtk_widget_destroy(mozzie->fileopendialog);
    if (mozzie->signal == 0) {
	
	mozzie->signal = 1;
    }
    /* --- Call the function that does the work. --- */
	gtk_signal_connect(GTK_OBJECT(mozzie->gd->geckoEmbed),
			   "title",
			   GTK_SIGNAL_FUNC(title_changed_cb), mozzie); 
    gtk_moz_embed_load_url(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed),
			   filename);
	g_free(tmp);
	/*g_free(tmpfile);*/
}

void menu_openf_cb(GtkMenuItem * menuitem, geckobrowser * mozzie)
{
    GtkStyle *xnew, *current;
    gchar *title = "Open Local File:";

    gchar *tmp = NULL;
    /* --- Create a new file selection widget --- */
    mozzie->fileopendialog = gtk_file_selection_new(title);
    gtk_signal_connect(GTK_OBJECT(mozzie->fileopendialog), "destroy",
		       GTK_SIGNAL_FUNC(NULL), mozzie);

    /* --- Connect the "ok" button --- */
    gtk_signal_connect(GTK_OBJECT
		       (GTK_FILE_SELECTION(mozzie->fileopendialog)->
			ok_button), "clicked",
		       GTK_SIGNAL_FUNC(openfile), mozzie);

    /* --- Connect the cancel button --- */
    gtk_signal_connect_object(GTK_OBJECT
			      (GTK_FILE_SELECTION
			       (mozzie->fileopendialog)->cancel_button),
			      "clicked",
			      (GtkSignalFunc) gtk_widget_destroy,
			      (gpointer) mozzie->fileopendialog);

    if (tmp) {
	gtk_file_selection_set_filename(GTK_FILE_SELECTION
					(mozzie->fileopendialog), tmp);

    }
    current = gtk_widget_get_default_style();
    xnew = gtk_style_copy(current);
    xnew->bg[GTK_STATE_ACTIVE] = mozilla;
    xnew->bg[GTK_STATE_NORMAL] = mozilla;
    gtk_widget_set_style(mozzie->fileopendialog, xnew);
    gtk_widget_show(mozzie->fileopendialog);
    gtk_grab_add(mozzie->fileopendialog);
}



void show_file_picker(gchar * title, geckobrowser * mozzie)
{
    GtkStyle *xnew, *current;


    mozzie->all =
	gtk_check_button_new_with_label(_
					("Save everything, including images and framesets?"));
    mozzie->filesavedialog =
	gtk_file_selection_new(_("Enter a filename to save as"));
    gtk_box_pack_start(GTK_BOX
		       (GTK_FILE_SELECTION(mozzie->filesavedialog)->
			action_area), mozzie->all, FALSE, FALSE, 0);
    gtk_widget_show(mozzie->all);

    gtk_signal_connect(GTK_OBJECT
		       (GTK_FILE_SELECTION(mozzie->filesavedialog)->
			ok_button), "clicked",
		       GTK_SIGNAL_FUNC(save_url), mozzie);
    gtk_signal_connect_object(GTK_OBJECT
			      (GTK_FILE_SELECTION
			       (mozzie->filesavedialog)->cancel_button),
			      "clicked",
			      (GtkSignalFunc) gtk_widget_destroy,
			      (gpointer) mozzie->filesavedialog);


    current = gtk_widget_get_default_style();
    xnew = gtk_style_copy(current);
    xnew->bg[GTK_STATE_ACTIVE] = mozilla;
    xnew->bg[GTK_STATE_NORMAL] = mozilla;
    gtk_widget_set_style(mozzie->filesavedialog, xnew);
    gtk_widget_show(mozzie->filesavedialog);
    gtk_grab_add(mozzie->filesavedialog);
    return;
}

static void on_save_image_ok(GtkWidget * button, geckobrowser * mozzie)
{

    gchar *filename, *image_link;
    gembed *hydra;

    g_print("hydra");
    hydra = get_current_browser_from_notebook(mozzie);

    if (hydra)
	mozzie->gd = hydra;
    g_print("Activado!");

    filename =
	gtk_file_selection_get_filename(GTK_FILE_SELECTION
					(mozzie->filesavedialog));

    if (!filename || !strcmp(filename, "")) {
	return;
    } else {

	image_link =
	    gtk_object_get_data(GTK_OBJECT
				(mozzie->filesavedialog), "link");
	mozilla_save_image(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed),
			   image_link, filename);
	gtk_widget_destroy(mozzie->filesavedialog);
    }
    return; 
}


void
save_image(geckobrowser * mozzie, gchar * image_link, gchar * image_name)
{

    GtkStyle *xnew, *current;

    mozzie->filesavedialog =
	gtk_file_selection_new(_("Enter a filename to save as"));

    gtk_object_set_data(GTK_OBJECT(mozzie->filesavedialog), "link",
			image_link);
    gtk_object_set_data(GTK_OBJECT(mozzie->filesavedialog), "name",
			image_name);
    gtk_entry_set_text(GTK_ENTRY
		       (GTK_FILE_SELECTION(mozzie->filesavedialog)->
			selection_entry), image_name);
    gtk_signal_connect(GTK_OBJECT
		       (GTK_FILE_SELECTION(mozzie->filesavedialog)->
			ok_button), "clicked",
		       GTK_SIGNAL_FUNC(on_save_image_ok), mozzie);
    gtk_signal_connect_object(GTK_OBJECT
			      (GTK_FILE_SELECTION
			       (mozzie->filesavedialog)->cancel_button),
			      "clicked",
			      (GtkSignalFunc) gtk_widget_destroy,
			      (gpointer) mozzie->filesavedialog);

    current = gtk_widget_get_default_style();
    xnew = gtk_style_copy(current);
    xnew->bg[GTK_STATE_ACTIVE] = mozilla;
    xnew->bg[GTK_STATE_NORMAL] = mozilla;
    gtk_widget_set_style(mozzie->filesavedialog, xnew);
    gtk_widget_show(mozzie->filesavedialog);
    gtk_grab_add(mozzie->filesavedialog); 

}


void savefile(GtkWidget * widget, geckobrowser * mozzie)
{

    gchar *title = "Save Dialog";
 
    show_file_picker(title, mozzie);
}


static void save_url(GtkWidget * widget, geckobrowser * mozzie)
{
    gchar *filename;
    gembed *hydra;

    g_print("hydra");
    hydra = get_current_browser_from_notebook(mozzie);

    if (hydra)
	mozzie->gd = hydra;
    g_print("Activado!");
    filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION
					       (mozzie->filesavedialog));
    if (!filename || !strcmp(filename, "")) {
	return;
    } else {
   g_print("Legio1");
	if (!mozilla_save
	    (GTK_MOZ_EMBED(mozzie->gd->geckoEmbed), filename,
	     gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON
					  (mozzie->all)))) {
	    gnome_error_dialog("What the Hell?");
	}
	   g_print("Legio2");
	gtk_widget_destroy(mozzie->filesavedialog);
    }
    return;
}

void menu_copy_cb(GtkMenuItem * menuitem, geckobrowser * mozzie)
{
    GtkEditable *editable;
    GtkWidget *widget;

    gembed *hydra;

    g_print("hydra");
    hydra = get_current_browser_from_notebook(mozzie);

    if (hydra)
	mozzie->gd = hydra;
    g_print("Activado!");
    widget = mozzie->gd->geckoEmbed;
    mozilla_copy_selection(GTK_MOZ_EMBED(widget));

    editable = GTK_EDITABLE(widget);

    gtk_editable_copy_clipboard(editable);

}

void menu_paste_cb(GtkMenuItem * menuitem, geckobrowser * mozzie)
{
    GtkEditable *editable;
    GtkWidget *widget;
    gembed *hydra;

    g_print("hydra");
    hydra = get_current_browser_from_notebook(mozzie);

    if (hydra)
	mozzie->gd = hydra;
    g_print("Activado!");

    widget = mozzie->gd->geckoEmbed;
    mozilla_paste_selection(GTK_MOZ_EMBED(widget));

    editable = GTK_EDITABLE(mozzie->urlEntry);

    gtk_editable_paste_clipboard(editable);
}

void menu_select_cb(GtkMenuItem * menuitem, geckobrowser * mozzie)
{
  mozilla_select_all(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed));
	
}

void finderror()
{
    GtkWidget *dialog;
    GtkStyle *xnew, *current;

    dialog = gnome_warning_dialog("Text not found!");
    current = gtk_widget_get_default_style();
    xnew = gtk_style_copy(current);
    xnew->bg[GTK_STATE_ACTIVE] = mozilla;
    xnew->bg[GTK_STATE_NORMAL] = mozilla;
    gtk_widget_set_style(dialog, xnew);
    gtk_widget_show(dialog);
}


static void find_dialog_ok_cb(GtkWidget * w, GtkWidget * window)
{
    GtkWidget *entry;
	geckobrowser *mozzie;
    gembed *hydra;

    mozzie= (geckobrowser *) gtk_object_get_data(GTK_OBJECT(window),"salamander");
    entry = (GtkWidget *) gtk_object_get_data(GTK_OBJECT(window), "entry");
    
	g_print("hydra");
    hydra = get_current_browser_from_notebook(mozzie);

    if (hydra)
	mozzie->gd = hydra;
    g_print("Activado!");
#define	GET_FIND_OPTION(window, name)	\
	gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(gtk_object_get_data(GTK_OBJECT(window), name)))

    mozzie->didFind =
	mozilla_find(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed),
		     gtk_entry_get_text(GTK_ENTRY(entry)),
		     !GET_FIND_OPTION(window, "ignore_case"),
		     GET_FIND_OPTION(window, "backwards"),
		     GET_FIND_OPTION(window, "auto_wrap"),
		     GET_FIND_OPTION(window, "entire_word"),
		     GET_FIND_OPTION(window, "in_frame"), mozzie->didFind);
    if (!mozzie->didFind)
	finderror();
}


void menu_find(GtkMenuItem * menuitem, geckobrowser * mozzie)
{
    GtkWidget *window, *hbox, *entry, *label, *button, *ignore_case,
	*back_wards, *auto_wrap, *entire_word, *in_frame;
    GtkStyle *xnew, *current;

    window = gtk_dialog_new();
    gtk_object_set_data(GTK_OBJECT(window), "salamander", mozzie);
    gtk_window_set_title(GTK_WINDOW(window), _("Find"));
    gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
    hbox = gtk_hbox_new(FALSE, 0);
    gtk_container_set_border_width(GTK_CONTAINER(hbox), 4);

    label = gtk_label_new(_("Find: "));
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);

    entry = gtk_entry_new();
    gtk_object_set_data(GTK_OBJECT(window), "entry", entry);
    gtk_signal_connect(GTK_OBJECT(entry), "activate",
		       GTK_SIGNAL_FUNC(find_dialog_ok_cb), window);
    gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);

    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), hbox, FALSE,
		       FALSE, 0);

    ignore_case = gtk_check_button_new_with_label(_("Ignore case"));
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(ignore_case), TRUE);
    gtk_object_set_data(GTK_OBJECT(window), "ignore_case", ignore_case);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), ignore_case,
		       FALSE, FALSE, 0);

    back_wards = gtk_check_button_new_with_label(_("Find backwards?"));
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(back_wards), FALSE);
    gtk_object_set_data(GTK_OBJECT(window), "backwards", back_wards);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), back_wards,
		       FALSE, FALSE, 0);

    auto_wrap = gtk_check_button_new_with_label(_("Wrap around"));
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(auto_wrap), FALSE);
    gtk_object_set_data(GTK_OBJECT(window), "auto_wrap", auto_wrap);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), auto_wrap,
		       FALSE, FALSE, 0);

    entire_word = gtk_check_button_new_with_label(_("Match entire word"));
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(entire_word), FALSE);
    gtk_object_set_data(GTK_OBJECT(window), "entire_word", entire_word);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), entire_word,
		       FALSE, FALSE, 0);

    in_frame = gtk_check_button_new_with_label(_("Search in frames"));
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(in_frame), FALSE);
    gtk_object_set_data(GTK_OBJECT(window), "in_frame", in_frame);
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), in_frame,
		       FALSE, FALSE, 0);

    button = gtk_button_new_with_label(_("Find"));
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->action_area),
		       button, FALSE, FALSE, 0);
    gtk_signal_connect(GTK_OBJECT(button), "clicked",
		       GTK_SIGNAL_FUNC(find_dialog_ok_cb), window);

    button = gtk_button_new_with_label(_("Close"));
    gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->action_area),
		       button, FALSE, FALSE, 0);
    gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
			      GTK_SIGNAL_FUNC(gtk_widget_destroy),
			      (gpointer) window);

    current = gtk_widget_get_default_style();
    xnew = gtk_style_copy(current);
    xnew->bg[GTK_STATE_ACTIVE] = mozilla;
    xnew->bg[GTK_STATE_NORMAL] = mozilla;
    gtk_widget_set_style(window, xnew);
    gtk_widget_show_all(window);
    gtk_widget_grab_focus(entry);
}

void print(GtkWidget * menuitem, geckobrowser * mozzie)
{
    /*printfile(mozzie);*/
}


void create_book_menu(geckobrowser * mozzie)
{
	GtkStyle *new5,*current;
    GtkWidget *sep1;
    GtkWidget *item = NULL;
    gint i;

    if (mozzie->coolMenu != NULL)
	gtk_widget_destroy(mozzie->coolMenu);

    mozzie->coolMenu = gtk_menu_new();
    gtk_menu_item_set_submenu(GTK_MENU_ITEM(mozzie->coolMenuItem),
			      mozzie->coolMenu);

    gtk_widget_show(mozzie->coolMenu);

    mozzie->coolAdd = gtk_menu_item_new_with_label("Add Cool Site");
    gtk_menu_append(GTK_MENU(mozzie->coolMenu), mozzie->coolAdd);
    gtk_signal_connect(GTK_OBJECT(mozzie->coolAdd), "activate",
		       GTK_SIGNAL_FUNC(addcoolsite), mozzie); 
    gtk_widget_show(mozzie->coolAdd);

    mozzie->coolEdit = gtk_menu_item_new_with_label("Edit Cool Sites");
    gtk_menu_append(GTK_MENU(mozzie->coolMenu), mozzie->coolEdit);
    gtk_signal_connect(GTK_OBJECT(mozzie->coolEdit), "activate",
		       GTK_SIGNAL_FUNC(edit_bookmarks), NULL); 
    gtk_widget_show(mozzie->coolEdit);

    sep1 = gtk_menu_item_new();
    gtk_menu_append(GTK_MENU(mozzie->coolMenu), sep1);
	gtk_widget_show(sep1);
	
    for (i = 0; i < g_list_length(bookmarks); i++) {
	BookmarkData *bmark = g_list_nth_data(bookmarks, i);


	if (bmark->pos == 0) {
	    item = gtk_menu_item_new_with_label(bmark->label);
	    gtk_menu_append(GTK_MENU(mozzie->coolMenu), item);
	    gtk_signal_connect(GTK_OBJECT(item), "activate",
			       GTK_SIGNAL_FUNC(bookmark_activate), mozzie); 
	}			
	gtk_object_set_data(GTK_OBJECT(item), "bmark", bmark);
	gtk_widget_show(item);
    }
	current = gtk_widget_get_default_style();
	new5 = gtk_style_copy(current);
    new5->bg[GTK_STATE_ACTIVE] = mozilla;
    new5->bg[GTK_STATE_NORMAL] = mozilla;
	gtk_widget_set_style(mozzie->coolMenu, new5);
}

void plugins(GtkWidget * menuitem, geckobrowser * mozzie)
{
 gtk_moz_embed_load_url(GTK_MOZ_EMBED(mozzie->gd->geckoEmbed),
			   "about:plugins");
}


void create_menu(geckobrowser * mozzie)
{
    GtkStyle *xnew, *current, *new2, *new3, *new4, *new5,*new6;
    GtkWidget *sep1;

    // create our menu bar
    mozzie->menubar = gtk_menu_bar_new();
    // create the file menu
    mozzie->fileMenuItem = gtk_menu_item_new_with_label("File");
    mozzie->fileMenu = gtk_menu_new();
    gtk_menu_item_set_submenu(GTK_MENU_ITEM
			      (mozzie->fileMenuItem), mozzie->fileMenu);

    mozzie->fileOpenNewBrowser =
	gtk_menu_item_new_with_label("Open New Window");
    gtk_widget_add_accelerator(mozzie->fileOpenNewBrowser, "activate",
			       mozzie->accelgroup, GDK_n, GDK_MOD1_MASK,
			       GTK_ACCEL_VISIBLE);
    gtk_menu_append(GTK_MENU(mozzie->fileMenu),
		    mozzie->fileOpenNewBrowser);
    gtk_signal_connect(GTK_OBJECT(mozzie->fileOpenNewBrowser), "activate",
		       GTK_SIGNAL_FUNC(menu_open_new_cb), mozzie);


    mozzie->fileOpenNewTab = gtk_menu_item_new_with_label("Open New Tab");
    gtk_widget_add_accelerator(mozzie->fileOpenNewTab, "activate",
			       mozzie->accelgroup, GDK_t, GDK_MOD1_MASK,
			       GTK_ACCEL_VISIBLE);
    gtk_menu_append(GTK_MENU(mozzie->fileMenu), mozzie->fileOpenNewTab);
    gtk_signal_connect(GTK_OBJECT(mozzie->fileOpenNewTab),
		       "activate",
		       GTK_SIGNAL_FUNC(menu_open_new_tab), mozzie);

    mozzie->fileOpen = gtk_menu_item_new_with_label("Open Local File...");
    gtk_widget_add_accelerator(mozzie->fileOpen, "activate",
			       mozzie->accelgroup, GDK_o, GDK_MOD1_MASK,
			       GTK_ACCEL_VISIBLE);
    gtk_menu_append(GTK_MENU(mozzie->fileMenu), mozzie->fileOpen);
    gtk_signal_connect(GTK_OBJECT(mozzie->fileOpen), "activate",
		       GTK_SIGNAL_FUNC(menu_openf_cb), mozzie);


    mozzie->fileSaveas =
	gtk_menu_item_new_with_label("Save Document As...");
    gtk_widget_add_accelerator(mozzie->fileSaveas, "activate",
			       mozzie->accelgroup, GDK_s, GDK_MOD1_MASK,
			       GTK_ACCEL_VISIBLE);
    gtk_menu_append(GTK_MENU(mozzie->fileMenu), mozzie->fileSaveas);
    gtk_signal_connect(GTK_OBJECT(mozzie->fileSaveas),
		       "activate", GTK_SIGNAL_FUNC(savefile), mozzie);

   /* mozzie->filePrint = gtk_menu_item_new_with_label("Print Document... ");
    gtk_widget_add_accelerator(mozzie->filePrint, "activate",
			       mozzie->accelgroup, GDK_p, GDK_MOD1_MASK,
			       GTK_ACCEL_VISIBLE);
    gtk_menu_append(GTK_MENU(mozzie->fileMenu), mozzie->filePrint);
    gtk_signal_connect(GTK_OBJECT(mozzie->filePrint),
		       "activate", GTK_SIGNAL_FUNC(print), mozzie);
  */
    sep1 = gtk_menu_item_new();
    gtk_menu_append(GTK_MENU(mozzie->fileMenu), sep1);


    mozzie->fileClose = gtk_menu_item_new_with_label("Close Window");
    gtk_widget_add_accelerator(mozzie->fileClose, "activate",
			       mozzie->accelgroup, GDK_w, GDK_MOD1_MASK,
			       GTK_ACCEL_VISIBLE);
    gtk_menu_append(GTK_MENU(mozzie->fileMenu), mozzie->fileClose);
    gtk_signal_connect(GTK_OBJECT(mozzie->fileClose),
		       "activate", GTK_SIGNAL_FUNC(menu_quit_cb), mozzie);

    mozzie->fileQuit = gtk_menu_item_new_with_label("Quit Salamander");
    gtk_widget_add_accelerator(mozzie->fileQuit, "activate",
			       mozzie->accelgroup, GDK_q, GDK_MOD1_MASK,
			       GTK_ACCEL_VISIBLE);
    gtk_menu_append(GTK_MENU(mozzie->fileMenu), mozzie->fileQuit);
    gtk_signal_connect(GTK_OBJECT(mozzie->fileQuit), "activate",
		       GTK_SIGNAL_FUNC(menu_quit_cb), mozzie);
    gtk_menu_bar_append(GTK_MENU_BAR(mozzie->menubar),
			mozzie->fileMenuItem);

    mozzie->editMenuItem = gtk_menu_item_new_with_label("Edit");
    mozzie->editMenu = gtk_menu_new();
    gtk_menu_item_set_submenu(GTK_MENU_ITEM
			      (mozzie->editMenuItem), mozzie->editMenu);

    mozzie->editCopy = gtk_menu_item_new_with_label("Copy Selection");
    gtk_widget_add_accelerator(mozzie->editCopy, "activate",
			       mozzie->accelgroup, GDK_c, GDK_MOD1_MASK,
			       GTK_ACCEL_VISIBLE);
    gtk_menu_append(GTK_MENU(mozzie->editMenu), mozzie->editCopy);
    gtk_signal_connect(GTK_OBJECT(mozzie->editCopy), "activate",
		       GTK_SIGNAL_FUNC(menu_copy_cb), mozzie);

    mozzie->editPaste = gtk_menu_item_new_with_label("Paste Selection");
    gtk_widget_add_accelerator(mozzie->editPaste, "activate",
			       mozzie->accelgroup, GDK_v, GDK_MOD1_MASK,
			       GTK_ACCEL_VISIBLE);
    gtk_menu_append(GTK_MENU(mozzie->editMenu), mozzie->editPaste);
    gtk_signal_connect(GTK_OBJECT(mozzie->editPaste), "activate",
		       GTK_SIGNAL_FUNC(menu_paste_cb), mozzie);


    mozzie->editSelect = gtk_menu_item_new_with_label("Select All");
    gtk_menu_append(GTK_MENU(mozzie->editMenu), mozzie->editSelect);
    gtk_signal_connect(GTK_OBJECT(mozzie->editSelect), "activate",
		       GTK_SIGNAL_FUNC(menu_select_cb), mozzie);
    /*gtk_widget_set_sensitive(mozzie->editSelect,FALSE);*/
	
    sep1 = gtk_menu_item_new();
    gtk_menu_append(GTK_MENU(mozzie->editMenu), sep1);

    mozzie->editFind =
	gtk_menu_item_new_with_label("Find Text In Web Page");
    gtk_widget_add_accelerator(mozzie->editFind, "activate",
			       mozzie->accelgroup, GDK_f, GDK_MOD1_MASK,
			       GTK_ACCEL_VISIBLE);
    gtk_menu_append(GTK_MENU(mozzie->editMenu), mozzie->editFind);
    gtk_signal_connect(GTK_OBJECT(mozzie->editFind), "activate",
		       GTK_SIGNAL_FUNC(menu_find), mozzie);



    gtk_menu_bar_append(GTK_MENU_BAR(mozzie->menubar),
			mozzie->editMenuItem);
    //view menu
    mozzie->viewMenuItem = gtk_menu_item_new_with_label("View");
    gtk_menu_bar_append(GTK_MENU_BAR(mozzie->menubar),
			mozzie->viewMenuItem);
    mozzie->viewMenu = gtk_menu_new();
    gtk_menu_item_set_submenu(GTK_MENU_ITEM
			      (mozzie->viewMenuItem), mozzie->viewMenu);

    mozzie->viewSource =
	gtk_menu_item_new_with_label("Source Of Web Page");
    gtk_widget_add_accelerator(mozzie->viewSource, "activate",
			       mozzie->accelgroup, GDK_h, GDK_MOD1_MASK,
			       GTK_ACCEL_VISIBLE);
    gtk_menu_append(GTK_MENU(mozzie->viewMenu), mozzie->viewSource);
    gtk_signal_connect(GTK_OBJECT(mozzie->viewSource), "activate",
		       GTK_SIGNAL_FUNC(menu_vsource), mozzie);


    mozzie->viewZoom = gtk_menu_item_new_with_label(_("Zoom Of Text"));
    gtk_menu_append(GTK_MENU(mozzie->viewMenu), mozzie->viewZoom);
    mozzie->viewZoommenu = gtk_menu_new();
    gtk_menu_item_set_submenu(GTK_MENU_ITEM(mozzie->viewZoom),
			      mozzie->viewZoommenu);

    mozzie->zoomin = gtk_menu_item_new_with_label(_("Zoom In"));
    gtk_signal_connect(GTK_OBJECT(mozzie->zoomin), "activate",
		       GTK_SIGNAL_FUNC(menu_vzoomin), mozzie);
    gtk_menu_append(GTK_MENU(mozzie->viewZoommenu), mozzie->zoomin);


    mozzie->zoom100 = gtk_menu_item_new_with_label(_("Zoom 100%"));
    gtk_signal_connect(GTK_OBJECT(mozzie->zoom100), "activate",
		       GTK_SIGNAL_FUNC(menu_vzoom100), mozzie);
    gtk_menu_append(GTK_MENU(mozzie->viewZoommenu), mozzie->zoom100);

    mozzie->zoomout = gtk_menu_item_new_with_label(_("Zoom Out"));
    gtk_signal_connect(GTK_OBJECT(mozzie->zoomout), "activate",
		       GTK_SIGNAL_FUNC(menu_vzoomout), mozzie);
    gtk_menu_append(GTK_MENU(mozzie->viewZoommenu), mozzie->zoomout);


    //cool menu
    mozzie->coolMenuItem = gtk_menu_item_new_with_label("Cool Site");
    
gtk_menu_bar_append(GTK_MENU_BAR(mozzie->menubar),
			 mozzie->coolMenuItem);
    create_book_menu(mozzie);

    //help menu
    mozzie->helpMenuItem = gtk_menu_item_new_with_label("Help");
    gtk_menu_bar_append(GTK_MENU_BAR(mozzie->menubar),
			mozzie->helpMenuItem);
    mozzie->helpMenu = gtk_menu_new();
    gtk_menu_item_set_submenu(GTK_MENU_ITEM
			      (mozzie->helpMenuItem), mozzie->helpMenu);

   
    mozzie->helpPlugins = gtk_menu_item_new_with_label("About Plugins..");
    gtk_menu_append(GTK_MENU(mozzie->helpMenu), mozzie->helpPlugins);


    gtk_signal_connect(GTK_OBJECT(mozzie->helpPlugins),
		       "activate", GTK_SIGNAL_FUNC(plugins), mozzie);
			   
	
    mozzie->helpAbout = gtk_menu_item_new_with_label("About Salamander..");
    gtk_menu_append(GTK_MENU(mozzie->helpMenu), mozzie->helpAbout);


    gtk_signal_connect(GTK_OBJECT(mozzie->helpAbout),
		       "activate", GTK_SIGNAL_FUNC(about), mozzie);
    // add it to the vbox
    gtk_box_pack_start(GTK_BOX(mozzie->vbox), mozzie->menubar, FALSE,	// expand
		       FALSE,	// fill
		       0);	// padding
    current = gtk_widget_get_default_style();
    xnew = gtk_style_copy(current);
    new2 = gtk_style_copy(current);
    new3 = gtk_style_copy(current);
    new4 = gtk_style_copy(current);
    new5 = gtk_style_copy(current);
	new6 = gtk_style_copy(current);
    xnew->bg[GTK_STATE_ACTIVE] = mozmenu;
    xnew->bg[GTK_STATE_NORMAL] = mozmenu;
    new3->bg[GTK_STATE_ACTIVE] = mozmenu5;
    new3->bg[GTK_STATE_NORMAL] = mozmenu5;
    new2->bg[GTK_STATE_ACTIVE] = mozmenu2;
    new2->bg[GTK_STATE_NORMAL] = mozmenu2;
    new4->bg[GTK_STATE_ACTIVE] = mozmenu3;
    new4->bg[GTK_STATE_NORMAL] = mozmenu3;
    new5->bg[GTK_STATE_ACTIVE] = mozmenu4;
    new5->bg[GTK_STATE_NORMAL] = mozmenu4;
	new6->bg[GTK_STATE_ACTIVE] = mozmenu9;
    new6->bg[GTK_STATE_NORMAL] = mozmenu9;
    gtk_widget_set_style(mozzie->menubar, xnew);
    gtk_widget_set_style(mozzie->fileMenu, new3);
    gtk_widget_set_style(mozzie->editMenu, new6);
    gtk_widget_set_style(mozzie->viewMenu, new2);
    gtk_widget_set_style(mozzie->viewZoommenu, new2);
    gtk_widget_set_style(mozzie->coolMenu, new4);
    gtk_widget_set_style(mozzie->helpMenu, new5);
    gtk_widget_show(mozzie->menubar);
}
